Subject: Re: Netlink handler for ethtool --show-rxfh breaks driver compatibility

From: Jakub Kicinski <[email-masked]>
Date: Wed, 17 Jul 2024 09:45:01 -0700

On Mon, 15 Jul 2024 18:46:53 +0300 Vladimir Oltean wrote:
> > They can provide a different number? Which number is the user
> > supposed to trust? Out of the 4 APIs we have? Or the NIC has
> > a different ring count depending on the API?  
> 
> To stay on point on GRXRINGS vs GCHANNELS, "man ethtool" does say
> "A channel is an IRQ and the set of queues that can trigger that IRQ."
> Doesn't sound either (a) identical or (b) that you can recover the # of
> rings from the # of channels, unless you make an assumption about how
> they are distributed to IRQs...

A bit short on time to write a proper reply, but thinking some more
about it, I think you're right. The choice of channels is not great.
It works today, but if we start stacking multiple Rx queues on a single
IRQ one day - things will get complicated. So let's go back to GRXRINGS
for now.